//*****************************************************//
//
// Unit: RsRegisterCOM
//
// Purpose: Simple component to register in-process and out of process COM servers
//
// Inherits From: TComponent
//
// Project: Rapid Misc
//
// Author: Jeff Hiscock -- jhiscock@rapidsi.com
//
// Date: April 2000
//
// Revisions
//
// Copyright www.rapidsi.com 2000
//******************************************************//
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "RsRegisterCOM.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TRsRegisterCOM *)
{
        new TRsRegisterCOM(NULL);
}
//---------------------------------------------------------------------------
__fastcall TRsRegisterCOM::TRsRegisterCOM(TComponent* Owner)
        : TComponent(Owner)
{
}
//---------------------------------------------------------------------------
namespace Rsregistercom
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TRsRegisterCOM)};
                 RegisterComponents("Rapid - Misc", classes, 0);
        }
}
//---------------------------------------------------------------------------


void __fastcall TRsRegisterCOM::Register()
{
   //TODO: Add your source code here
   if (FCOMType ==ctInProcess)
      DoInProcess();
   else
      DoOutProcess();

}

void __fastcall TRsRegisterCOM::DoInProcess()
{
        //TODO: Add your source code here
        HINSTANCE x = LoadLibrary(FCOMServer.c_str());

        String emessage;
        bool ok = true;

        if (x !=0)
        {
             FARPROC p = GetProcAddress(x,"DllRegisterServer");
             if (p !=NULL)
                 p();
             else
             {
               emessage = "RsRegisterCOM - cannot find DLLRegisterServer in the dll";
               ok = false;
             }

           FreeLibrary(x);
        }
        else
        {
          ok = false;
          emessage = "RsRegisterCOM - cannot load DLL";
        }

        if (!ok)
        {
           if (FOnError)
              OnError(this,emessage);
           else
              throw Exception(emessage);
        }

}

void __fastcall TRsRegisterCOM::DoOutProcess()
{
        //TODO: Add your source code here

        String CommandLine = FCOMServer + " /regserver";

         system(CommandLine.c_str());


}

void __fastcall TRsRegisterCOM::UnRegister()
{
        //TODO: Add your source code here
      if (FCOMType ==ctInProcess)
         DoUnRegInProcess();
      else
         DoUnRegOutProcess();
}

void __fastcall TRsRegisterCOM::DoUnRegInProcess()
{
        //TODO: Add your source code here
         HINSTANCE x = LoadLibrary(FCOMServer.c_str());

        String emessage;
        bool ok = true;

        if (x !=0)
        {
             FARPROC p = GetProcAddress(x,"DllUnregisterServer");
             if (p !=NULL)
                 p();
             else
             {
               emessage = "RsRegisterCOM - cannot find DLLUnRegisterServer in the dll";
               ok = false;
             }

           FreeLibrary(x);
        }
        else
        {
          ok = false;
          emessage = "RsRegisterCOM - cannot load DLL";
        }

        if (!ok)
        {
           if (FOnError)
              OnError(this,emessage);
           else
              throw Exception(emessage);
        }
}

void __fastcall TRsRegisterCOM::DoUnRegOutProcess()
{
        //TODO: Add your source code here
        String CommandLine = FCOMServer + " /unregserver";
        system(CommandLine.c_str());

}